<?php

namespace App\Policies;

use App\Models\UniPopUp;
use App\Models\User;
use Illuminate\Auth\Access\Response;

class UniPopUpPolicy
{
    /**
     * Determine whether the user can view any models.
     */
    public function viewAny(User $user): bool
    {
        return $user->hasAnyPermission([
            'create unipopup', 'edit unipopup', 'view unipopup', 'delete unipopup', 'restore unipopup', 'force delete unipopup'
        ]);
    }

    /**
     * Determine whether the user can view the model.
     */
    public function view(User $user, UniPopUp $uniPopUp): bool
    {
        return $user->hasPermissionTo('view unipopup');
    }

    /**
     * Determine whether the user can create models.
     */
    public function create(User $user): bool
    {
        return $user->hasPermissionTo('create unipopup');
    }

    /**
     * Determine whether the user can update the model.
     */
    public function update(User $user, UniPopUp $uniPopUp): bool
    {
        return $user->hasPermissionTo('edit unipopup');
    }

    /**
     * Determine whether the user can delete the model.
     */
    public function delete(User $user, UniPopUp $uniPopUp): bool
    {
        return $user->hasPermissionTo('delete unipopup');
    }

    /**
     * Determine whether the user can restore the model.
     */
    public function restore(User $user, UniPopUp $uniPopUp): bool
    {
        return $user->hasPermissionTo('restore unipopup');
    }

    /**
     * Determine whether the user can permanently delete the model.
     */
    public function forceDelete(User $user, UniPopUp $uniPopUp): bool
    {
        return $user->hasPermissionTo('force delete unipopup');
    }
}